import javax.sound.sampled.*;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;
import java.lang.*;
import java.util.*;
import javax.sound.midi.*;

class AbcPlayer extends Thread
{
public static final int DOF=60;
public static final int REF=62;
public static final int MIF=64;
public static final int FAF=65;
public static final int SOLF=67;
public static final int LAF=69;
public static final int SIF=71;
public static final int PAUSEF=83;

Synthesizer syn=null;
Instrument[] instr =null;
MidiChannel[] mc=null;
	
ArrayList MyArrayList;

volatile boolean PausePlay;
volatile boolean IsTerminated;

volatile int NoteIndex;

public AbcPlayer(ArrayList NoteArrayList)
{
	PausePlay=false;
	MyArrayList=NoteArrayList;
}


public void run()
{
	playTune();
}


public void PausePlayer()
{
	synchronized(this)
	{
	
		PausePlay=true;
	
	}
}

public void StopPlayer()
{
	PausePlayer();
	synchronized(this)
	{
	
		NoteIndex=-1;
		Sol.LNotePlayed.setText("");
	}
}


public void RestartPlayer()
{
	synchronized(this)
	{
	
		PausePlay=false;
		try
		{
			notify();
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
		}
	}
}

public void playTune()
{
	float frequency=0;
	float milliseconds;
	double RAD = 2.0 * Math.PI;
	int sampleRate = 8000;	
	NoteParser.Note MyNote;
	NoteIndex=0;
	while(true)
	{
		
		IsTerminated=false;
		
		
		if(NoteIndex==MyArrayList.size())
		{
			synchronized(this)
			{
				StopPlayer();
				Sol.BplayTune.setEnabled(true);
				Sol.BstopTune.setEnabled(false);
				Sol.BpauseTune.setEnabled(false);
				Sol.BstartSolfeggio.setEnabled(true);
				try
				{
					IsTerminated=true;
					this.wait();
				}
				catch(Exception e)
				{
					System.out.println(e.getMessage());
				}
			}
		}
			
		if(PausePlay)
		{
			synchronized(this)
			{
				try
				{
					this.wait();
				}
				catch(Exception e)
				{
					System.out.println(e.getMessage());
				}
			}
			
		}
		
		if(NoteIndex==-1)
			NoteIndex=0;
		
		MyNote = (NoteParser.Note) MyArrayList.get(NoteIndex);
		
		
		Sol.LNotePlayed.setText("Note: "+MyNote.NoteName);
	
		if(MyNote.NoteName.equals("DO"))
		{
			 frequency=DOF;
		}
		else if(MyNote.NoteName.equals("RE"))
		{
			 frequency=REF;
		}
		else if(MyNote.NoteName.equals("MI"))
		{
			 frequency=MIF;
		}
		else if(MyNote.NoteName.equals("FA"))
		{
			 frequency=FAF;
		}
		else if(MyNote.NoteName.equals("SOL"))
		{
			 frequency=SOLF;
		}
		else if(MyNote.NoteName.equals("LA"))
		{
			 frequency=LAF;
		}
		else if(MyNote.NoteName.equals("SI"))
		{
			 frequency=SIF;
		}
		else if(MyNote.NoteName.equals("PAUSE"))
		{
			 frequency=PAUSEF;
		}
	
	
		milliseconds=(MyNote.Duration)/*+100)/100*/;
		playNote((int)frequency,(int)milliseconds);

        
	
	
		NoteIndex++;
	}


}

private void playNote(int frequency,int duration)
{
		try
		{
		
		 	syn=MidiSystem.getSynthesizer();
		 	syn.open();
		 	instr = syn.getDefaultSoundbank().getInstruments();
			mc= syn.getChannels();

		 	programChange(71);
	
			
			mc[2].noteOn(frequency,700);
		}
		catch(Exception e)
		{
			e.printStackTrace();		
		}
		
		synchronized(this)
		{
			try
			{
				sleep(duration);
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
			
		}
		
		syn.close();
		
}

public boolean getIsTerminated()
{
	return IsTerminated;
}
private void programChange(int program) 
{
    if (instr != null)
    {
        syn.loadInstrument(instr[program]);
    }
    mc[2].programChange(program);
    
 
}
}