import javax.sound.sampled.*;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;
import java.lang.*;
import java.util.*;
import javax.sound.midi.*;

class KeySound extends Thread
{
	volatile String MyNote="";
	
	float frequency=0;
	double RAD = 2.0 * Math.PI;
	int sampleRate = 8000;	
	int BigDuration=10;
	Synthesizer syn=null;
	Instrument[] instr =null;
	MidiChannel[] mc=null;
	boolean IamOnlySleeping=false;
	
	public KeySound()
	{
		
	}
	
	synchronized public void SetNote(String note)
	{
		MyNote=note;
		notify();
		//System.out.println("mi sveglio");
	}
	synchronized public void StopSound()
	{
		if(!IamOnlySleeping)
			notify();
			
	//	System.out.println("mi sveglio");
	}
	
	
	public void run()
	{
		while(true)
		{
		
				
				if(MyNote.equals("DO"))
				{
					 frequency=AbcPlayer.DOF;
				}
				else if(MyNote.equals("RE"))
				{
					 frequency=AbcPlayer.REF;
				}
				else if(MyNote.equals("MI"))
				{
					 frequency=AbcPlayer.MIF;
				}
				else if(MyNote.equals("FA"))
				{
					 frequency=AbcPlayer.FAF;
				}
				else if(MyNote.equals("SOL"))
				{
					 frequency=AbcPlayer.SOLF;
				}
				else if(MyNote.equals("LA"))
				{
					 frequency=AbcPlayer.LAF;
				}
				else if(MyNote.equals("SI"))
				{
					 frequency=AbcPlayer.SIF;
				}
				else if(MyNote.equals("PAUSE"))
				{
					 frequency=AbcPlayer.PAUSEF;
				}
				else 
				{
					synchronized(this)
					{
						try
						{
							//System.out.println("vado adormire perch non ho premuto nessun tasto coeereto");
							IamOnlySleeping=true;
							wait();
							IamOnlySleeping=false;
							continue;
						}
						catch(Exception e)
						{
							System.out.println(e.getMessage());
						}
					}
				
				}		
				
				if(frequency!=0)
					playNote((int)frequency);
			
	
			 
        
	
		}
	
	}
		private void playNote(int frequency)
		{
		
				    
				try
				{
				
				 	syn=MidiSystem.getSynthesizer();
				 	syn.open();
				 	instr = syn.getDefaultSoundbank().getInstruments();
					mc= syn.getChannels();
	
				 	programChange(71);
			
					
					mc[2].noteOn(frequency,700);
				}
				catch(Exception e)
				{
					e.printStackTrace();		
				}
				
				synchronized(this)
				{
					try
					{
						
						//System.out.println("vado in wait per play note");
						
						
						wait();
						mc[2].noteOff(frequency);
						syn.close();
						MyNote="";
						
					/*	if(IsSoundStopped)
							notify();
					*/		
					}
					catch(Exception e)
					{
						e.printStackTrace();
					}
					
				}
				
			
		
		}
		
		
		private void programChange(int program) 
		{
            if (instr != null) {
                syn.loadInstrument(instr[program]);
            }
            mc[2].programChange(program);
            
         
        }
}