 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;
 import abc.notation.Tune;
 import abc.ui.swing.TuneBookTable;
 import abc.parser.TuneBook;
 import javax.swing.table.*;
 import abc.midi.TunePlayer;


class SelectTuneFrame extends JFrame {
	
	//dati in tabella
   	Object[][] data=null;
   	String [] titoli=null;
	TuneBook book=null;
	String myPath;
	myTable t;
	
	//nome file tmeporaneo
	final String FILE_NAME_TMP="tmp.abc";
	final int DEFAULT_DURATION=700;
	
	static String nome_canzone="";
	
	
	//Tune selected
	public static Tune SelectedTune;
	
	public static void launch(final JFrame f,String title)
    {
    	f.setTitle(title);
    	
    	f.setVisible(true);
    
    	f.addWindowListener(new WindowAdapter(){
    		public void windowClosed(WindowEvent e)
    		{
    			f.setVisible(false);
  
    			Sol.isActiveSelectTune = false;
    		}
    	});
  		 	
    }
	
	public  SelectTuneFrame(String path)
	{
		
		myPath=path;
		
		
		
		
		AddJTable();
		this.setResizable(false);
		
		pack();
		
		
		//Aggiungo l'evento del mouse sulla tabella
		t.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e)
		{
			//Doppio click
			if(e.getClickCount()==2)
			{
			
				int [] TuneNumber=book.getReferenceNumbers();
				for(int i=0;i<t.getRowCount() ;++i)
				{
					 Runtime r = Runtime.getRuntime();
					if(t.isRowSelected(i))
					{	
						
						//Prendo il tune iesimo
						Tune aTune=book.getTune(TuneNumber[i]);
					
						SelectedTune=aTune;
						//System.out.println(book.getTuneNotation(TuneNumber[i]) );
						
						
				  		//System.out.println(book.getTuneNotation(TuneNumber[i]));
						//salvo il tune in formato testo
						saveTune(book.getTuneNotation(TuneNumber[i]));
						Process p=null;
						
					
						//Creo il titolo della canzone per ottenerne l'hash code
						String title=new String();
						try
						{
							for(int j=0;j<aTune.getTitles().length;++j)
							title=title+aTune.getTitles()[j];
						
						}
						catch(Exception ev)
						{
							System.out.println(ev.getMessage());
						}
						nome_canzone=String.valueOf(title.hashCode());
						try
						{
								 p = r.exec(".\\convert.bat "+nome_canzone);
								 p.waitFor();
	
						}
						catch(Exception exc)
						{
								System.out.println(exc.getMessage());	
						}

						
						//Carico le immmagini 
						Sol.FrameSol.createImages();
						
						//Parso le note
						NoteParser tn =new NoteParser(book.getTuneNotation(TuneNumber[i]),DEFAULT_DURATION);
	              		
	              		//Inizializzo il SolControl
	              		Sol.SolController=new SolControl(NoteParser.NewNotes);
	              		
	              		//inizializzo il player 
	              		Sol.myap=new AbcPlayer(NoteParser.NewNotes);
	              		Sol.BplayTune.setEnabled(true);
	              		//inizializzo il solfeggio 
						Sol.BstartSolfeggio.setEnabled(true);
						
						 // Create application frame.
						setVisible(false);
						dispose();
						Sol.isActiveSelectTune = false;
						
						break;
				
					} //fine if
				
				}//fine for
			}//fine if
			
		}
		});
	}
	

  
    
	
	private void ReadData()
	{
	
	//Leggo i dai dati delle canzoni da file
	File file=null;
	
	try
	{
			file=new File (myPath);
			PreParsing(myPath);
			System.out.println(myPath);
			book =new TuneBook(file);
	}
	catch(Exception e )
	{
		System.out.println(e.getMessage());	
	}
	
	this.titoli=new String[]{"Number","Title","Composer"};
	
	
	
	int [] TuneNumber=book.getReferenceNumbers();
	

	
	data=new Object[TuneNumber.length][3];
	
	Tune aTune;
	for(int i=0;i<TuneNumber.length ;++i)
	{
		aTune = book.getTune(TuneNumber[i]);
		String title=new String();
		try
		{
			for(int j=0;j<aTune.getTitles().length;++j)
			title=title+aTune.getTitles()[j];
		
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
		}
			
		data[i][0]=String.valueOf(TuneNumber[i]);
		data[i][1]=(Object)title;
		data[i][2]=aTune.getComposer();
		
	}
	
	}
	void AddJTable()
	{
		ReadData();
		t=new myTable(data,titoli);
	
		t.setRowHeight(20);
		t.setGridColor(Color.gray);
	
		
			
		//Permette di selezionare una sola righa per volta
		t.setSelectionMode(0);
	
		for(int i=0; i < t.getColumnCount(); ++i) {
			TableColumn tc= t.getColumn(t.getColumnName(i));
			tc.setCellRenderer(new MyRenderer());
		}
		
		JScrollPane sp=new JScrollPane();
		sp.getViewport().setView(t);
		sp.setPreferredSize(new Dimension(400, 300));

		
		JPanel p=new JPanel();
		p.add(sp,BorderLayout.SOUTH);
		
		this.getContentPane().add(p,BorderLayout.SOUTH);
		
		
	
	}
	
	
	class MyRenderer extends DefaultTableCellRenderer {
		public Component getTableCellRendererComponent(JTable table,
									Object value,
									boolean isSelected,
									boolean hasFocus,
									int row,
									int column) {
			switch(column) {
				case 0:
					setHorizontalAlignment(JLabel.CENTER);
					break;
				case 1:
					setHorizontalAlignment(JLabel.LEFT);
					break;
				case 2:
					setHorizontalAlignment(JLabel.LEFT);
					/*	switch(row) {
						case 0:
							setBackground(Color.black);
							setForeground(Color.white);
							break;
						default:
							setBackground(Color.yellow);
							setForeground(Color.red);
							
							break;
					}*/
					break;
				
				default:
					break;
			}
			return super.getTableCellRendererComponent(table,
									value, isSelected, hasFocus,
									row, column);
		}
		
		
	}
	
	//Classe personalizzata che non permette l'editing sulle celle
	public class myTable extends JTable
	{
		public myTable(Object [][] cell,Object [] title)
		{
			
			super(cell,title);
		}
		

		public boolean isCellEditable(int row, int column) 
 		{
 			return false;
 		}
		
	}
	
	private void saveTune(String Tune)
    {
    	FileOutputStream out;
        PrintStream p;

                try
                {
                        out = new FileOutputStream(FILE_NAME_TMP);

                        p = new PrintStream( out );
		
							p.println (Tune);
							

                        p.close();
                }
                catch (Exception e)
                {
                        System.err.println ("Error writing to file");
                }	
                
    
    }
    
    void PreParsing(String file_path)
    {
    
      
      String stringtmp="";
      String file_content="";
	  int inc=0;
	  boolean isFileOK=true;
      //Leggo il file per il preparsing
      try
      {	
      FileInputStream fstream = new FileInputStream(file_path);
      DataInputStream in = new DataInputStream(fstream);
	  
	  while(in.available() != 0)
	  {
	  	stringtmp+=(in.readLine())+"\n";
	  		
	  }
	  
	  	in.close();
	  }
	  catch (Exception e)
	  {
	 		System.err.println(e.getMessage());
	  }
			
	//	System.out.println("ho terminato la lettura");
			
		String actual;
      	while (inc<stringtmp.length())
      	
				{
					
					actual =stringtmp.substring(inc,inc+1);
					
					file_content+=actual;
					
					
					if(actual.equals(":"))
					{
						
						do
						{
							
							inc++;
							actual =stringtmp.substring(inc,inc+1);
						
							if(!actual.equals(" "))
							{
								file_content+=actual;
								break;
							}	
							isFileOK=false;
							
						
						
						}
						while(true);

					}	
					
				
					
					inc++;			
					
					if(inc>stringtmp.length())
					{
						break;
					}
					
				}	
				
				if(!isFileOK)
				writePreParsing(file_path,file_content);
						
    }
    
    private void writePreParsing(String file_path,String file_content)
    {
    	FileOutputStream out;
        PrintStream p;

                try
                {
                        out = new FileOutputStream(file_path);

                        p = new PrintStream(out);
		
					
                        	p.println (file_content);

                        p.close();
                }
                catch (Exception e)
                {
                        System.err.println ("Error writing to file");
                }	
                
    
    }
    
}
