

/**
 * Sample application using Frame.
 *
 * @author 
 * @version 1.00 06/01/24
 */

 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 
 
public class SolFrame  {
    
    static private JPanel statusArea =new JPanel();
    static private JLabel status =new JLabel();
    static private ResourceBundle resources;
    
    
	private SolFrame()
	{  
		resources = ResourceBundle.getBundle("SolFrame",Locale.getDefault());
    }


    
    public static void launch(final JFrame f,String title,final int x,final int y,final int w,int h)
    {
    	f.setTitle(title);
    	f.setBounds(x,y,w,h);
    	f.setVisible(true);
    	statusArea.setBorder(BorderFactory.createEtchedBorder());
    	statusArea.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
    	statusArea.add(status);
    	status.setHorizontalAlignment(JLabel.LEFT);
    	f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

    	f.addWindowListener(new WindowAdapter(){
    		public void windowClosed(WindowEvent e)
    		{
    			System.exit(0);
    		}
    	});
  
    }
    
    public static void launch(final JFrame f,String title)
    {
    	f.setTitle(title);
    	f.setVisible(true);
   		f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

    	f.addWindowListener(new WindowAdapter(){
    		public void windowClosed(WindowEvent e)
    		{
    			System.exit(0);
    		}
    	});
    }
    static final public JPanel getStatusArea()
    {
    	return statusArea;
    }  
    
    static final public void showStatus(String s)
    {
    	status.setText(s);
    }
    
    static final String getResource(String key)
    {
    	return (resources==null) ? null : resources.getString(key);
    } 
    
}
